<script setup lang="ts">
  import { PRODUCT_LIST_PAGE_SIZE } from '~/helpers/constants';
  import type { CustomizedProductListing } from '~/composables/logic/useListing';
  import { ProductFilteringControlKey } from '~/helpers/injection';

  const LISTING_TYPE = 'productsFiltering';

  const injection = inject(ProductFilteringControlKey);

  const props = defineProps<{
    controller: ReturnType<typeof useModal>;
    value: { [key: string]: boolean };
    multipleSelection: boolean;
  }>();

  const initialized = ref(false);

  const {
    getElements,
    search,
    changeCurrentPage,
    getCurrentPage,
    getTotal,
    loading,
    allProductIds,
  } = useListing({
    listingType: LISTING_TYPE,
    defaultSearchCriteria: {
      limit: PRODUCT_LIST_PAGE_SIZE,
    },
  }) as CustomizedProductListing;

  onBeforeMount(async () => {
    await search({ ...criteria.value, loadAllIds: !!props.multipleSelection });

    initialized.value = true;
  });

  const criteria = ref({});

  const filteringIds = computed(() => {
    const canAdd: { [key: string]: boolean } = {};
    const canRemove: { [key: string]: boolean } = {};
    if (!props.multipleSelection) return { canAdd, canRemove };

    Array.from(allProductIds.value as string[]).forEach((id: string) => {
      if (props.value?.[id]) {
        canRemove[id] = true;
      } else {
        canAdd[id] = true;
      }
    });

    return {
      canAdd,
      canRemove,
    };
  });

  const handleChangePage = (p: number) => {
    changeCurrentPage(p, criteria.value);
  };

  const handleChangeCondition = async (cond: any) => {
    criteria.value = cond;

    await search({
      p: 1,
      loadAllIds: !!props.multipleSelection,
      ...criteria.value,
    });
  };
</script>

<template>
  <SwModal
    :controller="controller"
    :modal-title="$t('product.addProducts')"
    panel-class="instant-listing-container"
    offset="both"
    backdrop-display="static"
    :prevent-scroll="true"
  >
    <template #body>
      <SwLoading
        v-if="!initialized"
        class="text-primary z-loading absolute inset-0 bg-white text-3xl"
      />
      <div v-else class="flex h-full">
        <ListingController
          class="border-border h-full w-72 overflow-y-scroll border-r 2xl:w-80"
          :listing-type="LISTING_TYPE"
          :value="criteria"
          @change="handleChangeCondition"
        />

        <div class="h-full flex-1 overflow-y-scroll px-6 py-6 2xl:px-8">
          <div
            v-if="getTotal"
            class="xl:(items-center flex-row) mb-6 flex flex-col justify-between"
          >
            <p class="block text-lg font-bold">{{ getTotal }} {{ $t('product.products') }}</p>

            <div v-if="multipleSelection" class="flex items-center gap-4 lg:gap-6">
              <button
                class="color-primary text-sm font-medium"
                @click="injection?.add(filteringIds.canAdd)"
              >
                {{ `${$t('addAll')} (${Object.keys(filteringIds.canAdd ?? {})?.length})` }}
              </button>

              <div class="border-border h-5 border-l" />

              <button
                class="text-danger text-sm font-medium"
                @click="injection?.remove(filteringIds.canRemove)"
              >
                {{ `${$t('removeAdded')} (${Object.keys(filteringIds.canRemove ?? {})?.length})` }}
              </button>
            </div>
          </div>

          <SwPaginationProductList
            :data="getElements"
            :total="getTotal"
            :page-size="PRODUCT_LIST_PAGE_SIZE"
            :current-page="getCurrentPage"
            :is-loading="loading"
            @change-current-page="handleChangePage"
          >
            <template #default="item">
              <ProductsFilteringCard
                :show-bookmark-shortcut="injection?.showBookmarkShortcut"
                :data="item"
                :is-added="value?.[item.id] || false"
                @add="injection?.add({ [item.id]: true })"
                @remove="injection?.remove({ [item.id]: true })"
              >
                <template #select-button="data">
                  <slot name="select-button" v-bind="data" />
                </template>
              </ProductsFilteringCard>
            </template>
          </SwPaginationProductList>
        </div>
      </div>
    </template>
  </SwModal>
</template>

<style>
  .instant-listing-container {
    @media (min-width: 768px) {
      width: 95%;
      height: 95%;
    }

    .modal-body {
      @apply p-0;
    }
  }
</style>
